//************************************************************************
//*** Desription routine for Update-Utility
//************************************************************************
//*** Descripe.inc
//*** Version: 2.0
//*** Copyright (c) 2000-2001 NordTeam Gruppen
//*** (Code has been clarified OPEN SOURCE 22/9 2000).
//***
//*** Author......: Allan Kim Eriksen
//*** Created.....: 25/9 2000
//************************************************************************
// This is the description part.
//************************************************************************

    Property string pOutDir public ""

    Define cMaxFilelistEntry for 255

    Procedure Describe
        Local string strDFPath strTemp strTest sFileout sFiledir sOutdir
        local integer iLastBackSlash iActPos hId
        Local string sRootname sMessage sLogicalName sDisplayName
        Local integer iFilenum iMaxRec iNumRec StructHandle
        Get value of (frmdatabase(cnt3DBox(self))) to strTemp
        Get value of (diroutput(cnt3DBox(self))) to sOutdir
        //Set the new filelist
        Set_FileList strTemp
        //Set the DFPath to the new setting
        move strTemp to strDFPath
        Length strTemp to iLastBackSlash
        repeat
            mid strTemp to strTest 1 iLastBackSlash
            Decrement iLastBackSlash
        Until (strTest = "\")
        Left strDFPath to strDFPath iLastBackSlash
        Set_DFPath to strDFPath
        move strDFPath to sFiledir
        append sFiledir "\"

        if (trim(sOutdir) = "") move sFiledir to sOutdir
        else append sOutdir "\"

        Set pOutDir to sOutDir

        send cursor_wait to (cursor_control(current_object))
        Move 0 to iFilenum   //Start at top of current filelist
        Repeat
            Get_attribute DF_FILE_NEXT_USED of iFilenum to iFilenum
            Set current_position of (pStatus(cnt3DBox(self))) to iFilenum
            If iFilenum begin
                Get_attribute DF_FILE_ROOT_NAME of iFilenum to sRootname
                Get_attribute DF_FILE_LOGICAL_NAME of iFilenum to sLogicalName
                Get_attribute DF_FILE_DISPLAY_NAME of iFilenum to sDisplayName
                If ((Uppercase(trim(sRootname))) <> "FLEXERRS") begin
                    //if (uppercase(trim(sRootname)) = uppercase(trim(sLogicalName))) begin
                        //move (sOutdir + (trim(sRootname)) + ".DEF") to sFileout
                        Open iFilenum mode DF_EXCLUSIVE
                        //if (found) output_aux_file DF_AUX_FILE_DEF for iFilenum to sFileout //Opening of the file was succesful
                        if (found) Send DoDescribeFile iFilenum
                        Close iFilenum
                    //end
                end
            end
        Until (iFilenum = 0)
        move (sOutdir + "CODETYPE.NTA") to sFileout
        direct_output channel 1 sFileout
        Writeln "dummy"
        Close_output channel 1
        move (sOutdir + "CODEMAST.NTA") to sFileout
        direct_output channel 1 sFileout
        Writeln "dummy"
        Close_output channel 1

        //Get_filelist strTemp
        //copyfile strTemp to (left(sOutdir, (Length(sOutdir) -1)))
        //Copyfile is not the best solution!

//        move (sOutdir + "Filelist.ntf") to sFileout
//        Direct_output channel 1 sFileout
//        Move 0 to iFilenum   //Start at top of current filelist
//        For iFilenum From 1 to cMaxFilelistEntry
//            Get_attribute DF_FILE_ROOT_NAME of iFilenum to sRootname
//            Get_attribute DF_FILE_LOGICAL_NAME of iFilenum to sLogicalName
//            Get_attribute DF_FILE_DISPLAY_NAME of iFilenum to sDisplayName
//            Writeln sRootname
//            writeln sLogicalName
//            writeln sDisplayName
//        Loop
//        Close_output channel 1

        Set current_position of (pStatus(cnt3DBox(self))) to 250
        send cursor_ready to (cursor_control(current_object))

        Send info_box "Description is complete!"
    End_Procedure

Procedure DoDescribeFile integer Filenum
    Local string sv sOutDir sLogicalname sFileout sFieldname
    Local number nv
    Local integer iNoOffields iActPos iLastIndex iActIndex iNoOfSegments
    Get pOutDir to sOutDir
    Get_attribute DF_FILE_LOGICAL_NAME of Filenum to sLogicalname

    //*** FILE definition
    move (sOutdir + (trim(sLogicalname)) + ".NTA") to sFileout
    direct_output channel 1 sFileout
    Get_attribute DF_FILE_COMPRESSION of Filenum to nv
    move "" to sv
    If (nv = DF_FILE_COMPRESS_NONE) move "None" to sv
    If (nv = DF_FILE_COMPRESS_FAST) move "Fast" to sv
    If (nv = DF_FILE_COMPRESS_STANDARD) move "Standard" to sv
    If (nv = DF_FILE_COMPRESS_CUSTOM) move "Custom" to sv
    writeln "Compression, " sv
    Get_attribute DF_FILE_DISPLAY_NAME of Filenum to sv
    writeln "Display name, " sv
    Get_attribute DF_FILE_DRIVER of Filenum to sv
    writeln "Driver, " sv
    Get_attribute DF_FILE_INTEGRITY_CHECK of Filenum to nv
    move "" to sv
    IF (nv = DFTRUE) move "Yes" to sv
    else move "No" to sv
    writeln "Integrity check, " sv
    Get_attribute DF_FILE_IS_SYSTEM_FILE of Filenum to nv
    move "" to sv
    IF (nv = DFTRUE) move "Yes" to sv
    else move "No" to sv
    writeln "System file, " sv
    Get_attribute DF_FILE_LAST_INDEX_NUMBER of Filenum to iLastIndex
    move iLastIndex to sv
    writeln "Last index number, " sv
    Get_attribute DF_FILE_LOCK_TYPE of Filenum to nv
    move "" to sv
    IF (nv = DF_LOCK_TYPE_NONE) move "None" to sv
    IF (nv = DF_LOCK_TYPE_FILE) move "File" to sv
    IF (nv = DF_LOCK_TYPE_RECORD) move "Record" to sv
    writeln "Lock type, " sv
    Get_attribute DF_FILE_LOGICAL_NAME of Filenum to sv
    writeln "Logical name, " sv
    // DF_FILE_LOGIN currently not in NTA-definition
    Get_attribute DF_FILE_MAX_RECORDS of Filenum to nv
    move nv to sv
    writeln "Max records, " sv
    Get_attribute DF_FILE_MULTIUSER of Filenum to nv
    move "" to sv
    IF (nv = DF_FILE_USER_MULTI) move "Yes" to sv
    IF (nv = DF_FILE_USER_SINGLE) move "No" to sv
    writeln "Multiuser, " sv
    writeln "File number, " Filenum
    //DF_FILE_OWNER currently not in NTA-definition
    //DF_PHYSICAL_NAME currently not in NTA-definition
    Get_attribute DF_FILE_RECORD_IDENTITY of Filenum to nv
    move nv to sv
    writeln "Record identity, " sv
    Get_attribute DF_FILE_RECORD_LENGTH of Filenum to nv
    move nv to sv
    writeln "Record length, " sv
    Get_attribute DF_FILE_REUSE_DELETED of Filenum to nv
    move "" to sv
    If (nv = DF_FILE_DELETED_NOREUSE) move "No" to sv
    If (nv = DF_FILE_DELETED_REUSE) move "Yes" to sv
    writeln "Reuse deleted records, " sv
    Get_attribute DF_FILE_REVISION of Filenum to sv
    writeln "Revision, " sv
    Get_attribute DF_FILE_ROOT_NAME of Filenum to sv
    writeln "Root name, " sv
    Get_attribute DF_FILE_TRANSACTION of Filenum to nv
    Move "" to sv
    If (nv = DF_FILE_TRANSACTION_NONE) move "None" to sv
    If (nv = DF_FILE_TRANSACTION_CLIENT_ATOMIC) move "Client atomic" to sv
    If (nv = DF_FILE_TRANSACTION_SERVER_ATOMIC) move "Server atomic" to sv
    If (nv = DF_FILE_TRANSACTION_SERVER_LOGGED) move "Server logged" to sv
    writeln "Transaction, " sv
    //DF_FILE_TYPE currently not in NTA-definition
    Close_output channel 1

    //*** FIELD definition
    move (sOutdir + (trim(sLogicalname)) + ".NTB") to sFileout
    direct_output channel 1 sFileout
    Get_attribute DF_FILE_NUMBER_FIELDS of Filenum to iNoOfFields
    For iActPos From 1 to iNoOfFields
        //Fieldnumber is iActPos
        Get_attribute DF_FIELD_NAME of Filenum iActPos to sFieldname
        Writeln "Name, " iActpos ", " sFieldname
        Get_attribute DF_FIELD_INDEX of Filenum iActPos to nv
        Writeln "Main index," iActpos ", " nv
        Get_attribute DF_FIELD_LENGTH of Filenum iActPos to nv
        Writeln "Length," iActpos ", " nv
        Get_attribute DF_FIELD_OFFSET of Filenum iActPos to nv
        Writeln "Offset," iActpos ", " nv
        Get_attribute DF_FIELD_PRECISION of Filenum iActPos to nv
        Writeln "Precision," iActpos ", " nv
        Get_attribute DF_FIELD_RELATED_FIELD of Filenum iActPos to nv
        Writeln "Related field," iActpos ", " nv
        Get_attribute DF_FIELD_RELATED_FILE of Filenum iActPos to nv
        Writeln "Related file," iActpos ", " nv
        Get_attribute DF_FIELD_TYPE of Filenum iActPos to nv
        move "" to sv
        If (nv = DF_ASCII) move "Ascii" to sv
        If (nv = DF_BCD) move "Nummeric" to sv
        If (nv = DF_DATE) move "Date" to sv
        If (nv = DF_TEXT) move "Text" to sv
        If (nv = DF_BINARY) move "Binary" to sv
        If (nv = DF_OVERLAP) move "Overlap" to sv
        Writeln "Type, " iActPos ", " sv
    Loop
    Close_output channel 1

    //*** INDEX definition
    move (sOutdir + (trim(sLogicalname)) + ".NTC") to sFileout
    direct_output channel 1 sFileout
    For iActIndex From 1 to iLastIndex
        Get_attribute DF_INDEX_NUMBER_SEGMENTS of Filenum iActIndex to iNoOfSegments
        If (iNoOfSegments) begin
            Get_attribute DF_INDEX_TYPE of Filenum iActIndex to nv
            move "" to sv
            if (nv = DF_INDEX_TYPE_ONLINE) move "Online" to sv
            if (nv = DF_INDEX_TYPE_BATCH) move "Batch" to sv
            writeln "Type, " iActIndex ", , " sv
            For iActPos From 1 to iNoOfSegments
                Get_attribute DF_INDEX_SEGMENT_CASE of Filenum IActIndex iActPos to nv
                move "" to sv
                If (nv = DF_CASE_USED) move "Used" to sv
                if (nv = DF_CASE_IGNORED) move "Ignored" to sv
                writeln "Case, " iActIndex ", " iActPos ", " sv
                Get_attribute DF_INDEX_SEGMENT_DIRECTION of Filenum IActIndex iActPos to nv
                move "" to sv
                If (nv = DF_ASCENDING) move "Ascending" to sv
                if (nv = DF_DESCENDING) move "Descending" to sv
                writeln "Direction, " iActIndex ", " iActPos ", " sv
                Get_attribute DF_INDEX_SEGMENT_FIELD of Filenum IActIndex iActPos to nv
                writeln "Field, " iActIndex ", " iActPos ", " nv
            Loop
        end
    Loop
    Close_output channel 1

End_Procedure

