//AB/ Project Databaseopdatering
//AB/ Object prj is a VIEW_Project
//AB/   Set ProjectName to "Databaseopdatering"
//AB/   Set ProjectFileName to "Update.VW"
//AB/   Set GenerateFileName to "NONAME"

// Project Object Structure
//   Update_vw is a dbView
//     cnt3DBox is a Container3d
//       DirInput is a Dirform
//       pStatus is a Progressbar
//       Textbox1 is a Textbox
//       Textbox2 is a Textbox
//       pWorking is a Progressbar
//       pCallback is a Progressbar
//       frmFilelist is a Filform
//       frmDatabase is a Dirform
//     Button1 is a Button
//     Button2 is a Button

// Register all objects
Register_Object Button1
Register_Object Button2
Register_Object DirInput
Register_Object frmDatabase
Register_Object frmFilelist
Register_Object cnt3DBox
Register_Object Update_vw
Register_Object pCallback
Register_Object pStatus
Register_Object pWorking
Register_Object Textbox1
Register_Object Textbox2


//AB/ AppBuild VIEW

//AB-IgnoreStart

Use dfAllEnt.pkg

//AB-IgnoreEnd

ACTIVATE_VIEW Activate_Update_vw FOR Update_vw

Object Update_vw is a dbView

  //AB-StoreTopStart

  //Konstanter

  //String CR_LF 2  //In stead of the caracter-functions
  //Move ( (character (13)) + (character (10)) ) to CR_LF

  Use filform
  Use dirform
  Use dfprgres
  Use wincp850
  Use nofield.dg

  //Holds the fieldnumber for the choosen field that the missing fieldname is identical with.
  Property integer piChoosenField public 0

  //For errortreatment
  Property integer error_processing_state public 0
  Property integer OldErrId public 0
  Property integer piActFilenumber public 0
  Property string psActFilename public 0

  #INCLUDE Update.inc

  //AB-StoreTopEnd

  Set Label to "Databaseupdate"
  Set Size to 114 346
  Set Location to 6 7

  //AB-DDOStart


  //AB-DDOEnd

  Object cnt3DBox is a Container3d
    Set Size to 78 337
    Set Location to 1 2
    Object DirInput is a DirForm

      //AB-StoreTopStart

      //AB-StoreTopEnd

      Set Label to "Directory for descriptionfiles:"
      Set Label_Col_Offset to 3
      Set Label_Justification_Mode to jMode_Right
      Set Prompt_Button_Mode to pb_PromptOn
      Set Size to 13 233
      Set Location to 32 98

      //AB-StoreStart

      Set Status_help to "Choose directory where the descriptionfiles are placed."

      Procedure Prompt
        Local string stxt sModule
        Forward send prompt
        get value to stxt
        Get Module_Name to sModule
        Set_profile_string sModule "Databasedescription" to sTxt
      End_Procedure

      //AB-StoreEnd

    End_Object    // DirInput

    Object pStatus is a Progressbar

      //AB-StoreTopStart

      //AB-StoreTopEnd

      Set Border_Style to Border_StaticEdge
      Set Label to "Progressbar1"
      Set TypeFace to "MS Sans Serif"
      Set FontSize to 4 0
      Set Size to 13 233
      Set Location to 47 99

      //AB-StoreStart

      Set minimum_position to 0
      Set maximum_position to 250
      Set step_value to 1
      Set Current_position to 0

      //AB-StoreEnd

    End_Object    // pStatus

    Object Textbox1 is a Textbox
      Set Label to "Updated:"
      Set TypeFace to "MS Sans Serif"
      Set FontSize to 4 0
      Set Size to 10 35
      Set Location to 49 63
    End_Object    // Textbox1

    Object Textbox2 is a Textbox
      Set Label to "DBfilestatus:"
      Set TypeFace to "MS Sans Serif"
      Set FontSize to 4 0
      Set Size to 10 48
      Set Location to 62 53
    End_Object    // Textbox2

    Object pWorking is a Progressbar

      //AB-StoreTopStart

      //AB-StoreTopEnd

      Set Border_Style to Border_StaticEdge
      Set Label to "Progressbar1"
      Set TypeFace to "MS Sans Serif"
      Set FontSize to 4 0
      Set Size to 6 233
      Set Location to 62 99

      //AB-StoreStart

      Set minimum_position to 0
      Set maximum_position to 100
      Set step_value to 1
      Set Current_position to 0

      //AB-StoreEnd

    End_Object    // pWorking

    Object pCallback is a Progressbar

      //AB-StoreTopStart

      Function CallBack string callback_msg integer callback_type returns integer
        Local integer val1 val2 iCommaPos iCurrentpos
        Local number nOffset
        trim callback_msg to callback_msg
        If (Callback_type = DF_MESSAGE_PROGRESS_VALUE) begin
          Pos "," in callback_msg to iCommaPos
          Left callback_msg to val1 (iCommaPos -1)
          right callback_msg to val2 (length(callback_msg)-iCommaPos)
          calc (val2 / 100) to nOffset
          Calc (val1 / nOffset) to iCurrentpos
          Set current_position to iCurrentpos
        end
        else set current_position to 0
        Function_return FALSE   //Continue the process
      end_function

      //AB-StoreTopEnd

      Set Border_Style to Border_StaticEdge
      Set Label to "Progressbar1"
      Set TypeFace to "MS Sans Serif"
      Set FontSize to 4 0
      Set Size to 6 233
      Set Location to 68 99

      //AB-StoreStart

      Set minimum_position to 0
      Set maximum_position to 100
      Set step_value to 1
      Set Current_position to 0

      //AB-StoreEnd

    End_Object    // pCallback

    Object frmFilelist is a FilForm

      //AB-StoreTopStart

      //AB-StoreTopEnd

      Set Label to "Filelist.cfg:"
      Set Label_Col_Offset to 3
      Set Label_Justification_Mode to jMode_Right
      Set Prompt_Button_Mode to pb_PromptOn
      Set Size to 13 233
      Set Location to 17 99

      //AB-StoreStart

      Set Dialog_caption of (openfile(self)) to "Choose Visual DataFlex Database"
      Set Filter_String to  "Filelist.cfg (*.cfg)|*.cfg|All files (*.*)|*.*"
      Set DefaultDir to "Databasefilelist"

      Procedure Prompt
        Local string stxt sModule
        Forward send prompt
        get value to stxt
        Get Module_Name to sModule
        Set_profile_string sModule "Databasefilelist" to sTxt
      End_Procedure

      //AB-StoreEnd

    End_Object    // frmFilelist

    Object frmDatabase is a DirForm

      //AB-StoreTopStart

      //AB-StoreTopEnd

      Set Label to "Directories for the database:"
      Set Label_Col_Offset to 3
      Set Label_Justification_Mode to jMode_Right
      Set Prompt_Button_Mode to pb_PromptOn
      Set Size to 13 233
      Set Location to 2 98

      //AB-StoreStart

      Set Status_help to "Choose the directories where the databasefiles is placed."

      Procedure Prompt
        Local string stxt sModule
        Forward send prompt
        get value to stxt
        Get Module_Name to sModule
        Set_profile_string sModule "Databasedst" to sTxt
      End_Procedure


      //AB-StoreEnd

    End_Object    // frmDatabase

    Object chkTest Is A checkbox
        Set location to 62 5
        Set label to "Test"
        Set checked_state to true
    End_Object

  End_Object    // cnt3DBox

  Object Button1 is a Button

    //AB-StoreTopStart

    //AB-StoreTopEnd

    Set Label to "Start"
    Set Location to 82 80

    //AB-StoreStart

    Procedure OnClick
            Local string strTemp sInDir strFilelist
            local integer iError iTest
            Get value of (frmdatabase(cnt3DBox(self))) to strTemp
            Get value of (frmfilelist(cnt3DBox(self))) to strFilelist
            Get value of (dirinput(cnt3DBox(self))) to sInDir
            Get checked_state of (chkTest(cnt3DBox(self))) to iTest
            If (trim(strTemp) = "") begin
              increment iError
              send info_box "Choose database."
            end
            If (trim(strFilelist) = "") begin
              increment iError
              send info_box "Choose Filelist."
            end
            If (trim(sInDir) = "") begin
              increment iError
              send info_box "Choose directory for the descriptionfiles."
            end
            If not iError begin
              Set_profile_string "DEFAULTS" "Update database" to strTemp
              Set_profile_string "DEFAULTS" "Update filelist" to strFilelist
              Set_profile_string "DEFAULTS" "Update description" to sInDir
              Set_profile_string "DEFAULTS" "Update testmode" to (if(iTest = TRUE, "YES", "NO"))
              Send Update
            end
    End_procedure



    //AB-StoreEnd

  End_Object    // Button1

  Object Button2 is a Button

    //AB-StoreTopStart

    //AB-StoreTopEnd

    Set Label to "Exit"
    Set Location to 82 210

    //AB-StoreStart

    Procedure OnClick
      Send close_panel
    end_procedure

    //AB-StoreEnd

  End_Object    // Button2


  //AB-StoreStart

  Procedure activate
    Local string sTemp sModule
    Get Module_Name to sModule
    Get_profile_string sModule "Databasedst" to sTemp
    Set value of (frmDatabase(cnt3DBox(self))) to sTemp
    Get_profile_string sModule "Databasedescription" to sTemp
    Set value of (dirInput(cnt3DBox(self))) to sTemp
    Get_profile_string sModule "Databasefilelist" to sTemp
    Set value of (frmFilelist(cnt3DBox(self))) to sTemp
    Forward send activate
  End_Procedure

  //AB-StoreEnd

End_Object    // Update_vw

//AB/ End_Object    // prj
