//AB/ Project Databaseopdatering
//AB/ Object prj is a View_Project
//AB/     Set ProjectName to "Databaseopdatering"
//AB/     Set ProjectFileName to "update.vw"

// Project Object Structure
//   Update_vw is a dbView
//     cnt3DBox is a Container3d
//       frmDatabase is a dirform
//       frmFilelist is a FilForm
//       DirInput is a dirform
//       chkTest is a CheckBox
//       pStatus is a cProgressBar
//       Textbox1 is a Textbox
//       Textbox2 is a Textbox
//       pWorking is a cProgressBar
//       pCallback is a cProgressBar
//     Button1 is a Button
//     Button2 is a Button

// Register all objects
Register_Object Button1
Register_Object Button2
Register_Object chkTest
Register_Object cnt3DBox
Register_Object DirInput
Register_Object frmDatabase
Register_Object frmFilelist
Register_Object pCallback
Register_Object pStatus
Register_Object pWorking
Register_Object Textbox1
Register_Object Textbox2
Register_Object Update_vw


//AB/ AppBuild VIEW

//AB-IgnoreStart

Use Dirform.pkg
Use FilForm.Pkg
Use cProgressBar.pkg

//AB-IgnoreEnd

Activate_View Activate_Update_vw For Update_vw

Object Update_vw Is A dbView

    //AB-StoreTopStart
        
    //Konstanter
    
    Use nofield.dg
    
    //Holds the fieldnumber for the choosen field that the missing fieldname is identical with.
    Property Integer piChoosenField public 0
    
    //For errortreatment
    Property Integer error_processing_state public 0
    Property Integer OldErrId public 0
    Property Integer piActFilenumber public 0
    Property String psActFilename public 0
    Property String pTestfile public ""
    
    #Include Update.inc
    
    //AB-StoreTopEnd

    Set Label To "Databaseupdate"
    Set Size To 114 346
    Set Location To 6 7

    //AB-DDOStart


    //AB-DDOEnd

    Object cnt3DBox Is A Container3d
        Set Size To 78 337
        Set Location To 1 2
        Object frmDatabase Is A dirform
            Set Label To "Directories for the database:"
            Set Size To 13 233
            Set Location To 2 98
            Set Status_Help To "Choose the directories where the databasefiles is placed."
            Set Label_Col_Offset To 3
            Set Label_Justification_Mode To jMode_Right
            Set RegistrationValueName To "DatabaseDst"

            //AB-StoreStart
                                                                                                            
            //AB-StoreEnd

        End_Object    // frmDatabase

        Object frmFilelist Is A FilForm
            Set Label To "Filelist.cfg:"
            Set Size To 13 233
            Set Location To 17 99
            Set Label_Col_Offset To 3
            Set Label_Justification_Mode To jMode_Right
            Set RegistrationValueName To "Databasefilelist"
            Set Dialog_caption To "Choose Visual DataFlex Database"
            Set Filter_String To "Filelist.cfg (*.cfg)|*.cfg|All files (*.*)|*.*"

            //AB-StoreStart
                                                                                                                        
            //AB-StoreEnd

        End_Object    // frmFilelist

        Object DirInput Is A dirform
            Set Label To "Directory for descriptionfiles:"
            Set Size To 13 233
            Set Location To 32 98
            Set Label_Col_Offset To 3
            Set Label_Justification_Mode To jMode_Right
            Set RegistrationValueName To "Databasedesc"
            Set Dialog_caption To "Choose directory where the descriptionfiles are placed."

            //AB-StoreStart
                                                                                                            
            //AB-StoreEnd

        End_Object    // DirInput

        Object chkTest Is A CheckBox
            Set Label To "Test"
            Set Size To 10 31
            Set Location To 62 5

            //AB-StoreStart
                                                                                                                                    
            Set checked_state To True
            //AB-StoreEnd

        End_Object    // chkTest

        Object pStatus Is A cProgressBar
            Set piMaximum To 250
            Set piAdvanceBy To 1
            Set Location To 47 99
            Set Size To 13 233

            //AB-StoreStart
                                                                                                                                    
            //AB-StoreEnd

        End_Object    // pStatus

        Object Textbox1 Is A Textbox
            Set Label To "Updated:"
            Set FontSize To 4 0
            Set Location To 49 63
            Set Size To 10 35
            Set TypeFace To "MS Sans Serif"
        End_Object    // Textbox1

        Object Textbox2 Is A Textbox
            Set Label To "DBfilestatus:"
            Set FontSize To 4 0
            Set Location To 62 53
            Set Size To 10 48
            Set TypeFace To "MS Sans Serif"
        End_Object    // Textbox2

        Object pWorking Is A cProgressBar
            Set piAdvanceBy To 1
            Set Location To 62 99
            Set Size To 6 233

            //AB-StoreStart
                                                                                                                                    
            //AB-StoreEnd

        End_Object    // pWorking

        Object pCallback Is A cProgressBar

            //AB-StoreTopStart
            Function CallBack String callback_msg Integer callback_type Returns Integer
                Integer val1 val2 iCommaPos iCurrentpos
                Number nOffset
                Trim callback_msg To callback_msg
                If (Callback_type = DF_MESSAGE_PROGRESS_VALUE) Begin
                    Pos "," in callback_msg To iCommaPos
                    Left callback_msg To val1 (iCommaPos -1)
                    Right callback_msg To val2 (Length(callback_msg)-iCommaPos)
                    calc (val2 / 100) To nOffset
                    Calc (val1 / nOffset) To iCurrentpos
                    Set piPosition To iCurrentpos
                End
                Else Set piPosition To 0
                Function_Return False   //Continue the process
            End_Function
            
            //AB-StoreTopEnd

            Set piAdvanceBy To 1
            Set Location To 68 99
            Set Size To 6 233

            //AB-StoreStart
                        
            //AB-StoreEnd

        End_Object    // pCallback

    End_Object    // cnt3DBox

    Object Button1 Is A Button
        Set Label To "Start"
        Set Location To 82 80

        //AB-StoreStart
        
        Procedure OnClick
            String strTemp sInDir strFilelist sTestfile
            Integer iError iTest
            Get value Of (frmdatabase(cnt3DBox(Self))) To strTemp
            Get value Of (frmfilelist(cnt3DBox(Self))) To strFilelist
            Get value Of (dirinput(cnt3DBox(Self))) To sInDir
            Get checked_state Of (chkTest(cnt3DBox(Self))) To iTest
            If (Trim(strTemp) = "") Begin
                Increment iError
                Send info_box "Choose database."
            End
            If (Trim(strFilelist) = "") Begin
                Increment iError
                Send info_box "Choose Filelist."
            End
            If (Trim(sInDir) = "") Begin
                Increment iError
                Send info_box "Choose directory for the descriptionfiles."
            End
            If Not iError Begin
                Set_Profile_String "DEFAULTS" "Update database" To strTemp
                Set_Profile_String "DEFAULTS" "Update filelist" To strFilelist
                Set_Profile_String "DEFAULTS" "Update description" To sInDir
                Set_Profile_String "DEFAULTS" "Update testmode" To (If(iTest = True, "YES", "NO"))
                Send Update
                If (iTest) Begin
                    Get pTestFile To sTestfile
                    Insert (Character(32)) in sTestfile At 1
                    Append sTestfile (Character(32))
                    //send info_box sTestfile
                    //Runprogram wait "notepad.exe" sTestfile
                    Send vShellExecute "OPEN" "Notepad.exe" sTestfile ""     // Runprogram does not release focus
                End
            End
        End_Procedure
        
        //AB-StoreEnd

    End_Object    // Button1

    Object Button2 Is A Button
        Set Label To "Exit"
        Set Location To 82 210

        //AB-StoreStart
                
        Procedure OnClick
            Send close_panel
        End_Procedure
        
        //AB-StoreEnd

    End_Object    // Button2


    //AB-StoreStart
        
    //Procedure Activate
    //    Forward Send Activate
    //    Set value Of frmDatabase To "D:\TESTUPD"
    //    Set value Of frmFilelist To "D:\TESTUPD\Filelist.cfg"
    //    Set value Of DirInput To "D:\Opdatering\beskrivelse"
    //End_Procedure
    
    //AB-StoreEnd

End_Object    // Update_vw

//AB/ End_Object    // prj
